<?php
use PHPUnit\Framework\TestCase;

/**
 * Created by PhpStorm.
 * User: Viktor
 * Date: 01.05.2019
 * Time: 16:31
 */


class UserTest extends TestCase
{

    private $user;

    protected function setUp() : void
    {
        $this->user = new \App\Models\User();
    }

    protected function tearDown(): void
    {

    }

    public function additionProvider() {
        return [
            [
                'name',
                'email@email.com',
                'password'
            ]
        ];
    }


    /**
     * @dataProvider additionProvider
     */
    public function testRegister($name, $email, $password) {
        $user = $this->user->register(
            $name, $email, $password
        );

        $this->assertNotEmpty($user);
        $this->assertEquals($name, $user->getName());
        $this->assertEquals($email, $user->getEmail());

        $this->assertNotEmpty($user->getPassword());
        $this->assertNotEquals($password, $user->getPassword());

        $this->assertFalse($user->isActive());
    }


    /**
     * @dataProvider additionProvider
     */
    public function testVerify($name, $email, $password) {
        $user = $this->user->register(
            $name, $email, $password
        );

        $user->verify();

        $this->assertFalse($user->isWait());
        $this->assertTrue($user->isActive());
    }


    /**
     * @dataProvider additionProvider
     */
    public function  testAlreadyVerified ($name, $email, $password) {
        $user = $this->user->register(
            $name, $email, $password
        );
        $user->verify();
        $this->expectExceptionMessage('User verified');
        $user->verify();

    }



}